# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011-2014 Webkul Software Pvt Ltd (<http://webkul.com>).
#	 Author : Mohit Chandra (mohit@webkul.com)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
{
    'name': 'POS - Customers',
    'summary': 'Manage Customer in Point Of Sale',
    'version': '1.0',
    'category': 'Point Of Sale',
    "sequence": 1,
    'description': """
===============
POS - Customers
===============

Salient Features:
----------------

* **Use with existing POS, extra tab you have two buttons – Select Customer and – Create Customer.**

.. figure:: pos_customer/static/src/img/0.jpeg
   :width: 100%
   :alt: POS - Extra Tab
   :align: center  
   

* **Select Customer in current Order of your Point of Sale.**

.. figure:: pos_customer/static/src/img/1.jpeg
   :width: 100%
   :alt: POS - Select Customer
   :align: center  


* **Filter customer by name.**

.. figure:: pos_customer/static/src/img/2.jpeg
   :width: 100%
   :alt: POS - Filter Customer
   :align: center


* **Edit existing Customer`s information (without closing/reloading exiting POS Session).**

.. figure:: pos_customer/static/src/img/3.jpeg
   :width: 100%
   :alt: POS - Edit Customer
   :align: center


* **Create new Customer (without closing/reloading exiting POS Session).**

.. figure:: pos_customer/static/src/img/4.jpeg
   :width: 100%
   :alt: POS - Create Customer
   :align: center


.

**Help and Support**
================
.. |icon_features| image:: pos_customer/static/src/img/icon-features.png
.. |icon_support| image:: pos_customer/static/src/img/icon-support.png
.. |icon_help| image:: pos_customer/static/src/img/icon-help.png

* For DOCUMENTATION  - click here ( `VIEW BLOG <http://webkul.com/blog/openerp-pos-customers>`_  ) 
* For DEMO           - click here ( `VIEW DEMO <http://54.251.33.126:8038/?db=POS_Extensions>`_  ) 

|icon_help| `Help <https://webkul.com/ticket/open.php>`_ |icon_support| `Support <https://webkul.com/ticket/open.php>`_ |icon_features| `Request new Feature(s) <https://webkul.com/ticket/open.php>`_ 

Some features are based on pos_select_customer from GRAP, Groupement Régional Alimentaire de Proximité, http://www.grap.coop
""",
    "author": "Webkul Software Pvt. Ltd.,GRAP",
    'website': 'http://www.webkul.com',
    'depends': [
        'point_of_sale','pos_extra_header'
        ],
    'data': ['pos_customer_view.xml'],
    "images":['static/description/Banner.png'],
    'qweb': [
        'static/src/xml/pos_customer.xml',
    ],
    'js': [
        'static/src/js/wk_pos_main.js',
        'static/src/js/wk_pos_customer.js',
    ],
    'css': [
        'static/src/css/pos_customer.css',
    ],
    "installable": True,
    "application": True,
    "auto_install": False,
   # "price": 45,
   # "currency": 'EUR',
}
