function wk_openerp_pos_customers(instance, module){
	_t = instance.web._t;

	module.ScreenSelector.include({                                             
        add_popup: function(popup_name, popup){                                 
            popup.hide();                                                       
            this.popup_set[popup_name] = popup;                                 
            return this;                                                        
        },                                                                      
    });

	module.CustomerOrderWidget = module.PosBaseWidget.extend({
        template: 'CustomerOrderWidget',
        init: function(parent, options){
            this._super(parent,options);
            this.pos.bind('change:selectedOrder', this.refresh, this);
        },
        start: function(){
            this._super();
            this._build_widgets();
        },
        refresh: function(){
            this.renderElement();
            this._build_widgets();
        },
        _build_widgets: function(){

           if (this.get_name()==''){
                this.select_customer_button = new module.HeaderButtonWidget(this,{
                    label:_t('Select Customer'),
                    action: function(){
                        self.screen_selector.show_popup('select-customer');
                    },
                });
                this.select_customer_button.replace($('.placeholder-SelectCustomerButton'));
                this.select_customer_button.renderElement();

                this.create_customer_button = new module.HeaderButtonWidget(this,{
                    label:_t('Create Customer'),
                    action: function(){     
                        var mine = this;
                        var action = {
                                name:'Create Customer',
                                type: 'ir.actions.act_window',
                                res_model: 'pos.customer',
                                view_mode: 'tree,form',
                                view_type: 'form',
                                views: [[false, 'form']],
                                target: 'new',
                                context: {
                                    'create':true,
                                },
                                };
                            instance.client.action_manager.do_action(action,{
                            on_close: function(ev1) {
                                (new instance.web.Model('pos.customer')).call('get_last_created_customer_data')
                                    .fail(function(unused, event){
                                        //don't show error popup if it fails 
                                        event.preventDefault();
                                        console.error('Failed to fetch customer');
                                    })
                                    .done(function(result){
                                      mine.pos.get('customer_list').push(result);
                                      mine.pos.get('selectedOrder').set_client(result);
                                      mine.pos_widget.customer_order.refresh();
                                     });
                            }
                        }
                            ).fail(function(){   // error when loading models data from the backend
                                            alert('OpenERP seems to be Offline, please try after some time or Check your Connection !!!');
                                        }
                            );
                    },
                });
                this.create_customer_button.replace($('.placeholder-CreateCustomerButton'));
                this.create_customer_button.renderElement();
            }
            else{
                this.edit_customer_button = new module.HeaderButtonWidget(this,{
                    label:_t('Edit'),
                    action: function(){
                        var client_data = this.pos.get('selectedOrder').get_client();
                        var mine = this;
                        var action = {
                                name:'Edit Customer',
                                type: 'ir.actions.act_window',
                                res_model: 'pos.customer',
                                // res_id: client_data.id,
                                view_mode: 'tree,form',
                                view_type: 'form',
                                // views: [[false, 'list'], [false, 'form']],
                                views: [[false, 'form']],
                                target: 'new',
                                context: {
                                    'modify':true,
                                    'default_name':client_data.name,
                                    'default_partner_id':client_data.id,
                                },
                                // flags : {
                                //             action_buttons : true,
                                //             views_switcher:true,
                                //             search_view:true,
                                //             sidebar:true,
                                //             pager:true,
                                //             display_title:true,
                                //             search_disable_custom_filters:true
                                            
                                //         }
                                };
                            instance.client.action_manager.do_action(action,{
                            on_close: function(ev1) {
                                // reload view
                                var loaded = new instance.web.Model('res.partner').query(['name','contact_address','email','phone','mobile',]).filter([['id', '=', client_data.id]]).all()
                                .done(function(result){
                                
                                var customers_len = mine.pos.get('customer_list').update_me(result[0]);
                                
                                    $("#pos-selected-customer").html(result[0].name);
                                    
                                    });
                            }}

                            ).fail(function(){   // error when loading models data from the backend
                                            alert('OpenERP seems to be Offline, please try after some time or Check your Connection !!!');
                                        }
                            );


                           
                    },

                });
                this.edit_customer_button.replace($('.placeholder-EditCustomerButton'));
                this.edit_customer_button.renderElement();

                this.remove_customer_button = new module.HeaderButtonWidget(this,{
                    label:_t('Remove'),
                    action: function(){
                        this.pos.get('selectedOrder').set_client(undefined);
                        this.pos_widget.customer_order.refresh();
                        this.hide();
                    },
                });
                this.remove_customer_button.replace($('.placeholder-RemoveCustomerButton'));
                this.remove_customer_button.renderElement();
            }
        },

        get_name: function(){
            customer = this.pos.get('selectedOrder').get_client();
            return customer && customer.name || '';
        },
    });

    module.CustomerWidget = module.PosBaseWidget.extend({
        template: 'CustomerWidget',

        init: function(parent, options) {
            this._super(parent,options);
            this.model = options.model;
        },

        renderElement: function() {
            this._super();
            this.$('img').replaceWith(this.pos_widget.image_cache.get_image(this.model.get_image_url()));
            var self = this;
            $("a", this.$el).click(function(e){
                self.pos.get('selectedOrder').set_client(self.model.toJSON());
                self.pos_widget.customer_order.refresh();
                self.pos_widget.screen_selector.set_current_screen('products');
            });
        },
    });

    module.CustomerListScreenWidget = module.ScreenWidget.extend({
        template:'CustomerListScreenWidget',

        init: function(parent, options) {
            this._super(parent,options);
            this.customer_list = [];
        },

        start: function() {
            this._super();
            var self = this;
        },

        renderElement: function() {
            this._super();
            var self = this;
            // Delete old customers widget and display refreshed customers list
            for(var i = 0, len = this.customer_list.length; i < len; i++){
                this.customer_list[i].destroy();
            }
            this.customer_list = [];
            var customers = this.pos.get('customer_list_filter') || [];
            for(var i = 0, len = customers.models.length; i < len; i++){
                var customer = new module.CustomerWidget(this, {
                    model: customers.models[i],
                    click_product_action: this.click_product_action,
                });
                this.customer_list.push(customer);
                customer.appendTo(this.$('.customer-list'));
            }

            this.scrollbar = new module.ScrollbarWidget(this,{
                target_widget:   this,
                target_selector: '.customer-list-scroller',
                on_show: function(){
                    self.$('.customer-list-scroller').css({'padding-right':'62px'},100);
                },
                on_hide: function(){
                    self.$('.customer-list-scroller').css({'padding-right':'0px'},100);
                },
            });
            this.scrollbar.replace(this.$('.placeholder-ScrollbarWidget'));
        },
    }),

    module.SelectCustomerPopupWidget = module.PopUpWidget.extend({
        template:'SelectCustomerPopupWidget',
        
        start: function(){
            this._super();
            var self = this;
            this.customer_list_widget = new module.CustomerListScreenWidget(this,{});
        },

        show: function(){
            this._super();
            var self = this;
            this.reset_customers();
            this.customer_list_widget.replace($('.placeholder-CustomerListScreenWidget'));
            this.$('#customer-cancel').off('click').click(function(){
                self.pos_widget.screen_selector.set_current_screen('products');
            });

            this.$('#customer-searchbox input').keyup(function(event){
                pattern = $(this).val().toLowerCase();
                if(pattern){
                    var customers = self.pos.get('customer_list').filter_me(pattern);
                    self.pos.set({'customer_list_filter' : customers});
                    self.$('#customer-search-clear').fadeIn();
                    self.customer_list_widget.renderElement();
                }
                else{
                    self.reset_customers();
                }
            });

            this.$('#customer-search-clear').click(function(){
                self.reset_customers();
            });
        },

        reset_customers: function(){
            this.pos.set({'customer_list_filter' : this.pos.get('customer_list')});
            this.$('#customer-search-clear').fadeOut();
            this.customer_list_widget.renderElement();
            this.$('#customer-searchbox input').val('').focus();
        },

    });



    module.PosWidget.include({

        build_widgets: function(){
            this._super();
            
            this.customer_order = new module.CustomerOrderWidget(this,{});
            this.customer_order.appendTo(this.$('#pos_extra_header'));


            this.select_customer_popup = new module.SelectCustomerPopupWidget(this, {});
            this.select_customer_popup.appendTo($('.point-of-sale'));
            this.select_customer_popup.hide();
            this.screen_selector.popup_set['select-customer'] = this.select_customer_popup;

        },
    });


    module.Customer = Backbone.Model.extend({
        get_image_url: function(){
            return instance.session.url('/web/binary/image', {model: 'res.partner', field: 'image_small', id: this.get('id')});
        },
    });

    module.CustomerCollection = Backbone.Collection.extend({
        model: module.Customer,
        
        filter_me: function(pattern){
            res = new module.CustomerCollection();
            var reg = RegExp(pattern,"i");
            for(var i = 0, len = this.models.length; i < len; i++){
                res_reg = reg.exec(this.models[i].attributes.name);
                if (res_reg){
                    res.push(this.models[i]);
                }
            }
            return res;
        },

        update_me: function(customer_data){
            for(var i = 0, len = this.models.length; i < len; i++){
                if (this.models[i].attributes.id == customer_data.id){
                    this.models[i].attributes = customer_data;
                }
            }
            return this.models.length;
        },

    });


    var PosModelSuper = module.PosModel

    module.PosModel = module.PosModel.extend({

    load_server_data: function(){
    	var self = this;
    	var loaded = PosModelSuper.prototype.load_server_data.call(this);
    	loaded = loaded.then(function(){
    				return self.fetch(
    						'res.partner',
		                    ['name','contact_address','email','phone','mobile',],
		                    [['customer', '=', true]])
    				.then(function(customers){
    					self.set({'customer_list' : new module.CustomerCollection(customers)});
                    	self.set({'customer_list_filter' : new module.CustomerCollection(customers)});
                	});
    			});
        return loaded;
        },
    });
};